/*
 * ctrlreg.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * This code interfaces assembler instructions to access
 * special purpose context regsiters.
 *
 * This code is part of libssmt.a
 *
 */

#include "libssmt.h"


SS_CONTEXT_TYPE contextID(void)
{
  SS_WORD_TYPE cxtctrl;

  asm("scxtctrl %0" : "=r" (cxtctrl));
  return(cxtctrl & 0x0000001f);

} /* contextID() */


int activeContext_p(SS_CONTEXT_TYPE context)
{
  SS_WORD_TYPE acxt;

  asm("sacxt %0":"=r" (acxt));
  return(acxt & (1 << context));

} /* activeContext_p() */


void suspendContext(SS_CONTEXT_TYPE context)
{
  SS_WORD_TYPE acxt;

  asm("sacxt %0":"=r" (acxt));
  acxt &= ~(1 << context);
  asm("lacxt %0"::"r" (acxt));

} /* suspendContext() */


void resumeContext(SS_CONTEXT_TYPE context)
{
  SS_WORD_TYPE acxt;

  asm("sacxt %0":"=r" (acxt));
  acxt |= (1 << context);
  asm("lacxt %0"::"r" (acxt));

} /* resumeContext() */


