/*
 * ctrlreg.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * This code interfaces assembler instructions to access
 * context regsiters.
 *
 * This code is part of libssmt.a
 *
 */

#include "libssmt.h"


void writeContext(SS_CONTEXT_TYPE context,
                  unsigned int reg,
                  SS_WORD_TYPE value)
{
  if (reg < SS_REG_MAX)
    asm("wcxt %0, %1, %2" :: "r" (value), "r" (context), "r" (reg));
} /* writeContext */



SS_WORD_TYPE readContext(SS_CONTEXT_TYPE context,
                         unsigned int reg)
{
  SS_WORD_TYPE value;

  if (reg < SS_REG_MAX) 
    asm("rcxt %0, %1, %2" : "=r" (value) : "r" (context), "r" (reg));
  else
    value = 0;
  return value;

} /* readContext */

