/*
 * libssmt.h
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * 
 *
 * This file is part of my thesis work.
 *
 */


#ifndef LIBSSMT_H
#define LIBSSMT_H

#define SS_NUM_CONTEXT 32

typedef int SS_WORD_TYPE;
typedef short int SS_CONTEXT_TYPE;

SS_CONTEXT_TYPE contextID(void);
int activeContext_p(SS_CONTEXT_TYPE context);
void suspendContext(SS_CONTEXT_TYPE context);
void resumeContext(SS_CONTEXT_TYPE context);
void sendToContext(SS_WORD_TYPE data, SS_CONTEXT_TYPE context);
void receiveFromContext(SS_WORD_TYPE *data, SS_CONTEXT_TYPE context);
unsigned int testMsgFromContext(SS_CONTEXT_TYPE context);


#define SS_REG_I0       0
#define SS_REG_I1       1
#define SS_REG_I2       2
#define SS_REG_I3       3
#define SS_REG_I4       4
#define SS_REG_I5       5
#define SS_REG_I6       6
#define SS_REG_I7       7
#define SS_REG_I8       8
#define SS_REG_I9       9
#define SS_REG_I10      10
#define SS_REG_I11      11
#define SS_REG_I12      12
#define SS_REG_I13      13
#define SS_REG_I14      14
#define SS_REG_I15      15
#define SS_REG_I16      16
#define SS_REG_I17      17
#define SS_REG_I18      18
#define SS_REG_I19      19
#define SS_REG_I20      20
#define SS_REG_I21      21
#define SS_REG_I22      22
#define SS_REG_I23      23
#define SS_REG_I24      24
#define SS_REG_I25      25
#define SS_REG_I26      26
#define SS_REG_I27      27
#define SS_REG_I28      28
#define SS_REG_I29      29
#define SS_REG_I30      30
#define SS_REG_I31      31
#define SS_REG_F0       32
#define SS_REG_F1       33
#define SS_REG_F2       34
#define SS_REG_F3       35
#define SS_REG_F4       36
#define SS_REG_F5       37
#define SS_REG_F6       38
#define SS_REG_F7       39
#define SS_REG_F8       40
#define SS_REG_F9       41
#define SS_REG_F10      42
#define SS_REG_F11      43
#define SS_REG_F12      44
#define SS_REG_F13      45
#define SS_REG_F14      46
#define SS_REG_F15      47
#define SS_REG_F16      48
#define SS_REG_F17      49
#define SS_REG_F18      50
#define SS_REG_F19      51
#define SS_REG_F20      52
#define SS_REG_F21      53
#define SS_REG_F22      54
#define SS_REG_F23      55
#define SS_REG_F24      56
#define SS_REG_F25      57
#define SS_REG_F26      58
#define SS_REG_F27      59
#define SS_REG_F28      60
#define SS_REG_F29      61
#define SS_REG_F30      62
#define SS_REG_F31      63
#define SS_REG_HI       64
#define SS_REG_LO       65
#define SS_REG_FCC      66
#define SS_REG_PC       67
#define SS_REG_CXTCTRL  68
#define SS_MMU_CONFIG   69

#define SS_REG_MAX      (SS_MMU_CONFIG + 1)

void writeContext(SS_CONTEXT_TYPE context,
                  unsigned int reg,
                  SS_WORD_TYPE value);
SS_WORD_TYPE readContext(SS_CONTEXT_TYPE context,
                         unsigned int reg);



#endif
