/*
 * msg.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * This code interfaces assembler instructions to send and
 * receive messages between contexts in the ssmt.
 *
 * This code is part of libssmt.a
 *
 */

#include "libssmt.h"
#include <stdio.h>


void sendToContext(SS_WORD_TYPE data, SS_CONTEXT_TYPE context)
{
  asm("smsg %0, %1":: "r" (data), "r" (context));
} /* sendToContext */



void receiveFromContext(SS_WORD_TYPE *data, SS_CONTEXT_TYPE context)
{
  asm("rmsg %0, %1": "=r" (*data) : "r" (context));
} /* receiveFromContext */


unsigned int testMsgFromContext(SS_CONTEXT_TYPE context)
{
  SS_WORD_TYPE data = 0;

  asm("tmsg %0, %1" : "=r" (data) : "r" (context));
  return (unsigned int)data;
} /* testMsgFromContext */
