/*
 * ssmt-2.h
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * This file contains definitions for use of ssmt's
 * "context port" functional unit.
 *
 * This file is part of my thesis work.
 *
 */


#ifndef SSMT_2_H
#define SSMT_2_H

#define SS_NUM_CONTEXT 32

typedef int SS_WORD_TYPE;
typedef short int SS_CONTEXT_TYPE;


void setMMUconfig(SS_CONTEXT_TYPE context, SS_WORD_TYPE config);
SS_WORD_TYPE getMMUconfig(SS_CONTEXT_TYPE context);

int createThread(
      SS_WORD_TYPE threadId,
      SS_CONTEXT_TYPE context,
      SS_WORD_TYPE *stack,
      int (*func)(unsigned int, int *),
      void * parameters);
int waitThread(SS_WORD_TYPE threadId);

void readPort(SS_WORD_TYPE *data, SS_WORD_TYPE port);
void writePort(SS_WORD_TYPE data, SS_WORD_TYPE port);

SS_WORD_TYPE suspendContext(SS_CONTEXT_TYPE context);
SS_WORD_TYPE resumeContext(SS_CONTEXT_TYPE context);
int activeContext_p(SS_CONTEXT_TYPE context);

int swapThreadOut(
      SS_CONTEXT_TYPE context, 
      SS_WORD_TYPE *sp, 
      SS_WORD_TYPE *pc);

int swapThreadIn(
      SS_CONTEXT_TYPE context,
      SS_WORD_TYPE sp,
      SS_WORD_TYPE pc);


#endif
