/*
 * ssmt-2.h
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * This file contains definitions for use of ssmt's
 * "context port" functional unit.
 *
 * This file is part of my thesis work.
 *
 */


#ifndef SSMT_3_H
#define SSMT_3_H

#define SS_NUM_CONTEXT 32

typedef int SS_WORD_TYPE;
typedef short int SS_CONTEXT_TYPE;


void readPort(SS_WORD_TYPE *data, SS_WORD_TYPE port);
void writePort(SS_WORD_TYPE data, SS_WORD_TYPE port);

void loadMMUconfig(SS_WORD_TYPE config, SS_CONTEXT_TYPE context);
SS_WORD_TYPE getMMUconfig(SS_CONTEXT_TYPE context);

void loadContextUnitReg(SS_WORD_TYPE data, SS_WORD_TYPE reg);
SS_WORD_TYPE getContextUnitReg(SS_WORD_TYPE reg);

void putMessage(SS_WORD_TYPE data, SS_WORD_TYPE port);
SS_WORD_TYPE getMessage(SS_WORD_TYPE port);

void lock(SS_WORD_TYPE next_port, SS_WORD_TYPE lock);
SS_WORD_TYPE unlock(SS_WORD_TYPE lock);

void loadPCandResume(SS_WORD_TYPE pc, SS_WORD_TYPE context);
SS_WORD_TYPE getPCandStop(SS_WORD_TYPE context);

int createThread(
      SS_WORD_TYPE threadId,
      SS_CONTEXT_TYPE context,
      SS_WORD_TYPE *stack,
      int (*func)(unsigned int, int *),
      void * parameters);
int waitThread(SS_WORD_TYPE threadId);

SS_WORD_TYPE suspendContext(SS_CONTEXT_TYPE context);
SS_WORD_TYPE resumeContext(SS_CONTEXT_TYPE context);
int activeContext_p(SS_CONTEXT_TYPE context);

int swapThreadOut(
      SS_CONTEXT_TYPE context, 
      SS_WORD_TYPE *sp, 
      SS_WORD_TYPE *pc);

int swapThreadIn(
      SS_CONTEXT_TYPE context,
      SS_WORD_TYPE sp,
      SS_WORD_TYPE pc);


#endif
