# ssmt.s
#
# Implementation part of thread.h
# 
# Dominik Madon, LSL-EPFL, 1998.
# This file is part of my thesis work.
        
       	.align	2
	.globl	createThread
	.align	2
	.globl	waitThread
	.align	2
	.globl	returnThread

      	.align	2
	.globl	contextID

       	.align	2
       	.globl	activeContext_p
	.align	2
	.globl	suspendContext
	.align	2
	.globl	resumeContext

       	.align	2
	.globl	sendToPort
	.align	2
	.globl	receiveFromPort
	.align	2
	.globl	testPort

       	.align	2
	.globl	writeContext
	.align	2
	.globl	readContext

	.text


        
#        
# c r e a t e T h r e a d
# 
# Parameters
#   threadId
#   context
#   (stack)
#   (function to execute)
#   (function parameter)
#
# 0 is returned upon succes.
# 

       	.ent	createThread
createThread:
	subu	$sp,$sp,32
	sw	$31,8($sp)
	sw	$fp,4($sp)
	move	$fp,$sp
        sw      $8,12($fp)
        sw      $3,16($fp)
        sw      $16,20($fp)
        sw      $9,24($fp)
                                        # Writing other thread registers.
                                        # FIXME. could be shorter...

        lw      $9,48($fp)              # fifth parameter.
        scxtctrl $3
        andi    $3,$3,0x0000001f
        li      $8,0x5
eT1:    rcxt    $2,$3,$8
        wcxt    $2,$5,$8
        addi    $8,$8,0x1
        slti    $16,$8,0x46             # 70
        bne     $0,$16,eT1
                                        # Preparing context stack.
        li      $8,0x1d                 # 29
        wcxt    $6,$5,$8
                                        # Preparing context PC.
        li      $8,0x43                 # 67
        wcxt    $7,$5,$8
                                        # Preparing MMU config.
        li      $8,0x45                 # 69
        wcxt    $3,$5,$8
                                        # Port to master thread.
        li      $8,0x1f                 # 31
        wcxt    $4,$5,$8
                                        # Context parameters.
        li      $8,0x4                  # 4
        wcxt    $9,$5,$8
                                        # Starting context.
        sacxt   $2
        li      $3,0x1                  
        sll     $3,$3,$5                
        or      $2,$2,$3
        lacxt   $2

        move    $2,$0                   # Always ok.
                                
        lw      $8,12($fp)
        lw      $3,16($fp)
        lw      $16,20($fp)
        lw      $9,24($fp)
       	move	$sp,$fp			# sp not trusted here
	lw	$31,8($sp)
	lw	$fp,4($sp)
	addu	$sp,$sp,32
	j	$31
	.end	createThread


        
#        
# w a i t T h r e a d
#
# Parameters
#   $4 thread_Id
#
# return value returned by the context
#        
                        
	.ent	waitThread
waitThread:
	subu	$sp,$sp,32
	sw	$31,8($sp)
	sw	$fp,4($sp)
	move	$fp,$sp
        rmsg    $2,$4                   # First value (nothing)
        rmsg    $2,$4                   # return value
	move	$sp,$fp			# sp not trusted here
	lw	$31,8($sp)
	lw	$fp,4($sp)
	addu	$sp,$sp,32
	j	$31
	.end	waitThread



        
# r e t u r n T h r e a d
# 
# send a termination message to the
# creator.
#
# Parameters
#   $4 return value
# 

        .ent    returnThread
returnThread:        
        lw      $31,28($fp)             # restoring caller id.
        smsg    $0,$31            
        smsg    $4,$31
        scxtctrl $5
        andi    $5,$5,0x0000001f
        sacxt   $2
        li      $3,0x1                  # preparing mask.
        sll     $3,$3,$5                
        nor     $3,$3,$3                # inverting.
        and     $2,$2,$3
        lacxt   $2

        .end    returnThread




#        
# s w a p T h r e a d I n
# 
# Parameters
#   $4 context
#   $5 (addr)
#
# 0 is returned upon succes.
# 

       	.ent	swapThreadIn
swapThreadIn:
	subu	$sp,$sp,32
	sw	$31,8($sp)
	sw	$fp,4($sp)
	move	$fp,$sp
        sw      $8,12($fp)
        sw      $3,16($fp)
        sw      $16,20($fp)

        move    $2,$5
        lw      $8,0x0
sTI1:   lw      $3,($5)
        wcxt    $3,$4,$8
        addi    $8,$8,0x1
        addi    $5,$5,0x4
        slti    $16,$8,0x46             # 70
        bne     $0,$16,sTI1

        move    $2,$0                   # Always ok.
                                
        lw      $8,12($fp)
        lw      $3,16($fp)
        lw      $16,20($fp)
       	move	$sp,$fp			# sp not trusted here
	lw	$31,8($sp)
	lw	$fp,4($sp)
	addu	$sp,$sp,32
	j	$31
	.end	swapThreadIn


        

#        
# s w a p T h r e a d O u t
# 
# Parameters
#   $4 context
#   $5 (addr)
#
# 0 is returned upon succes.
# 

       	.ent	swapThreadOut
swapThreadOut:
	subu	$sp,$sp,32
	sw	$31,8($sp)
	sw	$fp,4($sp)
	move	$fp,$sp
        sw      $8,12($fp)
        sw      $3,16($fp)
        sw      $16,20($fp)

        move    $2,$5
        lw      $8,0x0
sTO1:   rcxt    $3,$4,$8
        sw      $3,($5)
        addi    $8,$8,0x1
        addi    $5,$5,0x4
        slti    $16,$8,0x46             # 70
        bne     $0,$16,sTO1

        move    $2,$0                   # Always ok.
                                
        lw      $8,12($fp)
        lw      $3,16($fp)
        lw      $16,20($fp)
       	move	$sp,$fp			# sp not trusted here
	lw	$31,8($sp)
	lw	$fp,4($sp)
	addu	$sp,$sp,32
	j	$31
	.end	swapThreadOut


        

# c o n t e x t I D
#
# return context ID of the caller.
#
# no parameters
#
# contextID is returned
#
        
        .ent    contextID
contextID:
        scxtctrl $2
        andi    $2,$2,0x0000001f
        j       $31
        .end    contextID



#        
# a c t i v e C o n t e x t _ p
#
# return 1 if the given context is running and 0 otherwise.
#                      
# parameter
#   $4 context number
#
# 1 if the context is running.      
#
        
        .ent    activeContext_p
activeContext_p:
	subu	$sp,$sp,32
	sw	$31,8($sp)
	sw	$fp,4($sp)
	move	$fp,$sp
        sw      $5,12($fp)
        sw      $6,16($fp)
        sacxt   $2
        li      $6,0x1
        sll     $5,$6,$4
        and     $2,$2,$5
        beq     $2,$0,aC_p1
        li      $2,0x1
        j       aC_p2
aC_p1:  move    $2,$0
aC_p2:  lw      $5,12($fp)
        lw      $6,16($fp)
	move	$sp,$fp			# sp not trusted here
	lw	$31,8($sp)
	lw	$fp,4($sp)
	addu	$sp,$sp,32
	j	$31
        .end    activeContext_p


# s u s p e n d C o n t e x t
#
# stop execution of the given context.
#
# parameters:   
#   $4 context to stop
#
       	.ent	suspendContext
suspendContext:
	subu	$sp,$sp,32
	sw	$31,8($sp)
	sw	$fp,4($sp)
	move	$fp,$sp
        sw      $2,12($fp)        
        sw      $3,16($fp)
# critical section                                        
        sacxt   $2
        li      $3,0x1                  # preparing mask.
        sll     $3,$3,$4                
        nor     $3,$3,$3                # inverting.
        and     $2,$2,$3
        lacxt   $2
# end of critical section        
        lw      $3,16($fp)        
        lw      $2,12($fp)        
       	move	$sp,$fp			# sp not trusted here
	lw	$31,8($sp)
	lw	$fp,4($sp)
	addu	$sp,$sp,32
	j	$31
	.end	suspendContext


#        
# r e s u m e C o n t e x t
#
# resume execution of the given context.
#
# parameters:   
#   $4 context to resume
#
       	.ent	resumeContext
resumeContext:
	subu	$sp,$sp,32
	sw	$31,8($sp)
	sw	$fp,4($sp)
	move	$fp,$sp
        sw      $2,12($fp)        
        sw      $3,16($fp)
# critical section                                        
        sacxt   $2
        li      $3,0x1                  # preparing mask.
        sll     $3,$3,$4                
        or      $2,$2,$3
        lacxt   $2
# end of critical section        
        lw      $3,16($fp)        
        lw      $2,12($fp)        
       	move	$sp,$fp			# sp not trusted here
	lw	$31,8($sp)
	lw	$fp,4($sp)
	addu	$sp,$sp,32
	j	$31
	.end	resumeContext

        

# s e n d T o P o r t 
#
# send a word data to a given port.
#
# parameters:
#   $4 data to send
#   $5 port number                
#
        .ent sendToPort
sendToPort:  
        smsg    $4,$5
	j	$31
        .end sendToPort


        
#        
# r e c e i v e F r o m P o r t
#
# receive a word data to a given port.
#
# parameters:
#   $4 (data read)
#   $5 port number
#
        .ent receiveFromPort
receiveFromPort:  
	subu	$sp,$sp,32
	sw	$31,8($sp)
	sw	$fp,4($sp)
	move	$fp,$sp
        sw      $6,16($fp)
        rmsg    $6,$5
        sw      $6,($4)
        lw      $6,16($fp)
	move	$sp,$fp			# sp not trusted here
	lw	$31,8($sp)
	lw	$fp,4($sp)
	addu	$sp,$sp,32
	j	$31
        .end receiveFromPort



#        
# t e s t P o r t
#
# test if there is a waiting context attached to a port.
#        
# parameters:
#   $4 port number                
#
# returns 1 if a context is waiting a message.
# returns 2 if a context has written a message.
# if the given port is not used 0 is returned.
#        
        .ent testPort
testPort:
        tmsg    $2,$4
	j	$31
        .end testPort




#
# w r i t e C o n t e x t       
#
# Write a context register.
#
# parameters:   
#   $4 context
#   $5 target register
#   $6 value
#        
        .ent writeContext
writeContext:
        wcxt    $6,$4,$5
        j       $31
        .end writeContext




#
# r e a d C o n t e x t       
#
# Read a context register.
#
# parameters:   
#   $4 context
#   $5 target register
#
# return the value hold by the register
#                        
        .ent readContext
readContext:
        rcxt    $2,$4,$5
        j       $31
        .end readContext
