/*
 * bench-call-1.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998, 1999
 *
 * The goal of this executable is to time function calls,
 * thread call with creation, thread call w/o creation.
 *
 * */

#include <stdio.h>
#include <string.h>
#include "ssmt-3.h"


#define EXEC_NAME               "bench-call-1"

#define FALSE                   0
#define TRUE                    1



int thread_func_direct(unsigned int me, int * param)
{
  return(param[0] + param[1]);
} /* thread_func_direct */



int thread_func_service (unsigned int me, int * param)
{
  for(;;) {
    putMessage(getMessage(0x2222) + getMessage(0x2222), 0x2222);
  }
} /* thread_func_service */



void main(int argc, char **argv)
{
  unsigned int me = 0;          /* context id for myself */
  unsigned int i,j;
  SS_WORD_TYPE msg;             /* message to transmit/receive */
  int *stack;
  int a[2];

  fprintf(stderr, "[%d] %s begin\n", me, EXEC_NAME);
  fprintf(stderr, "[%d] initializing stack\n", me);

  stack = (int *) malloc(8*1024*32*sizeof(int));

  loadMMUconfig(0, 1);
  loadMMUconfig(0, 2);

  a[0] = 10;
  a[1] = 21;

  fprintf(stderr, "[%d] Calling 'thread_func_direct' in context 1\n", me);
  createThread(2, 2, &stack[192*1024], &thread_func_direct, a);
  fprintf(stderr, "[%d] thread(%d) = %d\n", me, 2, waitThread(2));

  fprintf(stderr, 
          "[%d] Starting 'thread_func_direct' as service in context 1\n", 
          me);
  createThread(1, 1, &stack[64*1024], &thread_func_service, NULL);

  for(i = 0; i < 100; i++)
    j += i + (j >> 2);
   
  putMessage(a[0], 0x2222);
  putMessage(a[1], 0x2222);
  i = getMessage(0x2222);
  fprintf(stderr, "[%d] Calling service(%d) = %d\n", me, 1, i);
  
  fprintf(stderr, "[%d] Direct call of 'thread_func_direct'\n", me);
  i = thread_func_direct(1, a);
  fprintf(stderr, "[%d] returned(%d) = %d\n", me, 1, i);



  fprintf(stderr, "[%d] Calling 'thread_func_direct' in context 1\n", me);
  createThread(2, 2, &stack[192*1024], &thread_func_direct, a);
  fprintf(stderr, "[%d] thread(%d) = %d\n", me, 2, waitThread(2));

  putMessage(a[0], 0x2222);
  putMessage(a[1], 0x2222);
  i = getMessage(0x2222);
  fprintf(stderr, "[%d] Calling service(%d) = %d\n", me, 1, i);

  fprintf(stderr, "[%d] Direct call of 'thread_func_direct'\n", me);
  i = thread_func_direct(1, a);
  fprintf(stderr, "[%d] returned(%d) = %d\n", me, 1, i);


  free(stack);

  fprintf(stderr, "[%d] %s end\n", me, EXEC_NAME);

}


