/*
 * test-interrupt-1.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998, 1999, 2000
 *
 * The goal of this executable is to check out reaction to
 * interrupts by a context.
 *
 *
 */

#include <stdio.h>
#include <string.h>
#include "ssmt-3.h"


#define EXEC_NAME               "bench-interrupt-1"

#define FALSE                   0
#define TRUE                    1



int child_func(unsigned int me, int * param)
{
  SS_WORD_TYPE msg;
  unsigned int i = 0;

  while (i < 5) {
    msg = getMessage(10000);
    fprintf(stderr, "[%d] (%d) catched an interrupt [%d] !\n",
            me, i++, msg);
  } /* while */  

  return(msg);
} /* child_func */





void main(int argc, char **argv)
{
  unsigned int me = 0;          /* context id for myself */
  unsigned int i,j;
  SS_WORD_TYPE msg;             /* message to transmit/receive */
  SS_WORD_TYPE sp[8], pc[8];
  int *stack;
  int a;


  fprintf(stderr, "[%d] %s begin\n", me, EXEC_NAME);
  fprintf(stderr, "[%d] initializing stack\n", me);

  stack = (int *) malloc(8*1024*32*sizeof(int));

  loadMMUconfig(0, 1);

  fprintf(stderr, "[%d] executing context 1\n", me);
  createThread(1, 1, &stack[32*1024], &child_func, &a);

  fprintf(stderr, "[%d] thread(%d) = %d\n", me, 1, waitThread(1));

  free(stack);

  fprintf(stderr, "[%d] %s end\n", me, EXEC_NAME);

}


