/*
 * bench-swap-2.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998, 1999
 *
 * The goal of this executable is to test swapping context
 * in/out. Two processes calculating fibonacci's numbers are running
 * on 1 context one after the other (10 swap in/out).
 *
 * */

#include <stdio.h>
#include <string.h>
#include "ssmt-3.h"


#define EXEC_NAME               "bench-swap-2"

#define FALSE                   0
#define TRUE                    1



int child_func(unsigned int me, int * param)
{
  SS_WORD_TYPE msg;
  int prime[200];
  unsigned int i, j, index, max, prime_p;
  
  prime[0] = 1;
  prime[1] = 2;
  prime[2] = 3;
  index = 2;

  for(i = 4; index < 200; i++) {
    max = i / 2;
    prime_p = TRUE;
    j = 1;
    do {
      if ((i % prime[j]) == 0)
        prime_p = FALSE;
      j++;
    } while ((j < index) && (prime_p));
    do {
      j = prime[index] + 1;
      if ((i % j) == 0)
        prime_p = FALSE;
      j++;
    } while ((j <= max) && (prime_p));
    if (prime_p) {
      prime[++index] = i;
    } /* if */
  } /* for */

  return(prime[index - 1]);
} /* child_func */





void main(int argc, char **argv)
{
  unsigned int me = 0;          /* context id for myself */
  unsigned int i,j;
  SS_WORD_TYPE msg;             /* message to transmit/receive */
  SS_WORD_TYPE sp[8], pc[8];
  int *stack;
  int a, b;

  fprintf(stderr, "[%d] %s begin\n", me, EXEC_NAME);
  fprintf(stderr, "[%d] initializing stack\n", me);

  stack = (int *) malloc(8*1024*32*sizeof(int));

  loadMMUconfig(0, 1);
  loadMMUconfig(0, 2);

  a = 10;
  b = 20;

  fprintf(stderr, "[%d] executing context 1\n", me);
  createThread(1, 1, &stack[32*1024], &child_func, &a);

  for(j = 0; j < 2000; j++);
  fprintf(stderr, "[%d] threadout(1)\n", me);
  swapThreadOut(1, &sp[1], &pc[1]);
  fprintf(stderr, "[%d] thread(1) stopped (pc=0x%08x sp=0x%08x)\n", 
          me, pc[1], sp[1]);

  fprintf(stderr, "[%d] executing context 2\n", me);
  createThread(2, 1, &stack[192*1024], &child_func, &b);

  for(i = 0; i < 5; i++) {
    SS_CONTEXT_TYPE temp;

    for(j = 0; j < 2000; j++);
    fprintf(stderr, "[%d] swap out thread %d in context %d\n", 
            me, 2, 1);
    swapThreadOut(1, &sp[2], &pc[2]);
    fprintf(stderr, "[%d] swap in thread %d in context %d\n", 
            me, 1, 1);
    swapThreadIn(1, sp[1], pc[1]);

    for(j = 0; j < 2000; j++);
    fprintf(stderr, "[%d] swap out thread %d in context %d\n", 
            me, 1, 1);
    swapThreadOut(1, &sp[1], &pc[1]);
    fprintf(stderr, "[%d] swap in thread %d in context %d\n", 
            me, 2, 1);
    swapThreadIn(1, sp[2], pc[2]);
  }


  fprintf(stderr, "[%d] thread(%d) = %d\n", me, 1, waitThread(1));

  fprintf(stderr, "[%d] threadin(5)\n", me);
  swapThreadIn(1, sp[2], pc[2]);

  fprintf(stderr, "[%d] thread(%d) = %d\n", me, 2, waitThread(2));

  free(stack);

  fprintf(stderr, "[%d] %s end\n", me, EXEC_NAME);

}


