/* prime.c
 *
 * This code search fo prime numbers.
 *
 * Dominik Madon (madon@lslsun4) on Wed Sep 16 1998 at 14:50:00
 *
 *  o Creation
 *
 */

#include <stdio.h>
#include "libssmt.h"


#define TRUE            1
#define FALSE           0
#define DEFAULT_LIMIT   10000
#define DEFAULT_ALLOC   2000

void main(int argc, char **argv)
{

  unsigned int limit = DEFAULT_LIMIT, i = 0, j;
  unsigned int *prime, max_value = 0;
  int is_prime;

  if (argc == 2) {
    sscanf(argv[1], "%i", &limit);
    if (limit > 0) {
      fprintf(stderr, "argument must be a positive integer\n");
      exit(1);
    }
  }

  prime = (unsigned int *) calloc(DEFAULT_ALLOC, sizeof(unsigned int));
  if (!prime) {
    fprintf(stderr, "unable to allocate memory\n");
    exit(1);
  }

  prime[max_value++] = 1;
  i = 1;

  while (i++ < limit) {
    is_prime = TRUE;
    j = 1;
    while ((j < max_value) && is_prime)
      if ((i % prime[j++]) == 0)
        is_prime = FALSE;
    if (is_prime)
      prime[max_value++] = i;
  }

/*    for(j = 0; j < max_value; j++) */
/*      fprintf(stderr, "%d is prime\n", prime[j]); */

} /* main */
