/*
 * test-call-3.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * The goal of this executable is to measure function calls
 * and thread creation.
 *
 */

#include <stdio.h>
#include <string.h>
#include "ssmt-2.h"


#define EXEC_NAME               "test-call-3"

#define FALSE                   0
#define TRUE                    1



int global_value;
int *ptr;

int child_func(unsigned int me, int * param)
{
  SS_WORD_TYPE msg;

  fprintf(stderr, "[%d] child_func(param:%d)\n", me, *param);
  global_value += 0x10 << me;
  fprintf(stderr, "[%d] global value = 0x%08x\n", me, global_value);
  return(*param - 9);
} /* child_func */


int garbage_func(unsigned int me, int * param)
{
  unsigned int i, div;
  unsigned int prime[10];
  unsigned t = 1001;

  i = 10;
  while(i) {
    div = t - 1;
    while (div && (t % div))
      div--;
    if (div == 1)
      prime[10 - i] = t;
    i--;
  }

  return 1;
}


void main(int argc, char **argv)
{
  unsigned int me;              /* context id for myself */
  unsigned int i;
  SS_WORD_TYPE msg;             /* message to transmit/receive */
  int *stack;
  int a, b;

  me = 0;

  fprintf(stderr, "[%d] %s begin\n", me, EXEC_NAME);
  fprintf(stderr, "[%d] addr child_func: 0x%08x\n", me, &child_func);

  global_value = 0x100000;

  fprintf(stderr, "[%d] global value = 0x%08x\n", me, global_value);

  fprintf(stderr, "[%d] initializing stack\n", me);
  stack = (int *) malloc(64 * 1024 * sizeof(int));

  fprintf(stderr, "[%d] initializing MMU config\n", me);

  setMMUconfig(1, 0);
  setMMUconfig(2, 0);
  setMMUconfig(3, 0);
  setMMUconfig(4, 0);
  setMMUconfig(5, 0);
  setMMUconfig(6, 0);
  setMMUconfig(7, 0);

  fprintf(stderr, "[%d] executing garbage func()\n", me);

  createThread(2, 2, &stack[2047], &garbage_func, NULL);
  createThread(3, 3, &stack[3071], &garbage_func, NULL);
  createThread(4, 4, &stack[4095], &garbage_func, NULL);
  createThread(5, 5, &stack[5120], &garbage_func, NULL);

  a = 111;
  b = 222;

  fprintf(stderr, "[%d] executing context 1\n", me);

  createThread(1, 1, &stack[1023], &child_func, &a);

  a = waitThread(1);

  b = child_func(me, &b);

  fprintf(stderr, "[%d] executing context 1\n", me);

  createThread(1, 1, &stack[1023], &child_func, &a);

  a = waitThread(1);

  b = child_func(me, &b);

  a = waitThread(2);
  a = waitThread(3);
  a = waitThread(4);
  a = waitThread(5);

  free(stack);

  fprintf(stderr, "[%d] %s end\n", me, EXEC_NAME);

}












