/*
 * test-child.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * The goal of this executable is to test thread creation/termination.
 *
 */

#include <stdio.h>
#include <string.h>
#include "ssmt-2.h"


#define EXEC_NAME               "test-child-2"

#define FALSE                   0
#define TRUE                    1



int global_value;
int *ptr;

int child_func(unsigned int me, int * param)
{
  SS_WORD_TYPE msg;

  /* synchro */

  readPort(&msg, 0x10000 + me);

  fprintf(stderr, "[%d] child_func(param:%d)\n", me, *param);
  fprintf(stderr, "[%d] global value = 0x%08x\n", me, global_value);
  global_value += 0x10 << me;
  fprintf(stderr, "[%d] global value = 0x%08x\n", me, global_value);
  if (me < 3)
    writePort(msg, 0x10000 + me + 1);
  return(me+2000);
} /* child_func */



void main(int argc, char **argv)
{
  unsigned int me;              /* context id for myself */
  unsigned int i;
  SS_WORD_TYPE msg;             /* message to transmit/receive */
  int *stack;
  int a, b, c;

  me = 0;

  fprintf(stderr, "[%d] %s begin\n", me, EXEC_NAME);
  fprintf(stderr, "[%d] addr child_func: 0x%08x\n", me, &child_func);

  global_value = 0x100000;

  fprintf(stderr, "[%d] initializing context 1\n", me);
  fprintf(stderr, "[%d] global value = 0x%08x\n", me, global_value);

  fprintf(stderr, "[%d] initializing stack\n", me);
  stack = (int *) malloc(1024 * sizeof(int));

  a = 111;
  b = 229;
  c = 776;

  fprintf(stderr, "[%d] executing context 1\n", me);
  createThread(1, 1, &stack[255], &child_func, &a);
  fprintf(stderr, "[%d] executing context 2\n", me);
  createThread(2, 2, &stack[511], &child_func, &b);
  fprintf(stderr, "[%d] executing context 3\n", me);
  createThread(3, 3, &stack[767], &child_func, &c);


  writePort(1, 0x10001);

  a = waitThread(1);
  b = waitThread(2);
  c = waitThread(3);

  ptr = &global_value;
  fprintf(stderr, "[%d] global value = 0x%08x\n", me, *ptr);
  fprintf(stderr, "[%d] a = 0x%08x\n", me, a);
  fprintf(stderr, "[%d] b = 0x%08x\n", me, b);
  fprintf(stderr, "[%d] c = 0x%08x\n", me, c);

  free(stack);

  fprintf(stderr, "[%d] %s end\n", me, EXEC_NAME);

}
