/*
 * test-child.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * The goal of this executable is to test thread creation/termination.
 *
 */

#include <stdio.h>
#include <string.h>
#include "ssmt-2.h"


#define EXEC_NAME               "test-child"

#define FALSE                   0
#define TRUE                    1



int global_value;
int *ptr;

int child_func(unsigned int me, int * param)
{
  SS_WORD_TYPE msg;

  /* synchro */

  readPort(&msg, 0x1000 + me);

  fprintf(stderr, "[%d] child_func(param:%d)\n", me, *param);
  fprintf(stderr, "[%d] global value = 0x%08x\n", me, global_value);
  global_value += 0x10 << me;
  fprintf(stderr, "[%d] global value = 0x%08x\n", me, global_value);
  if (me < 0x1003)
    writePort(msg, 0x1000 + me + 1);
  return(me + (10 * (*param)));
} /* child_func */



void main(int argc, char **argv)
{
  unsigned int me;              /* context id for myself */
  unsigned int i;
  SS_WORD_TYPE msg;             /* message to transmit/receive */
  int *stack;
  int a, b, c;

  me = 0;

  fprintf(stderr, "[%d] %s begin\n", me, EXEC_NAME);
  fprintf(stderr, "[%d] addr child_func: 0x%08x\n", me, &child_func);

  global_value = 0x100000;

  fprintf(stderr, "[%d] initializing context 1\n", me);
  fprintf(stderr, "[%d] global value = 0x%08x\n", me, global_value);
  fprintf(stderr, "[%d] initializing stack\n", me);
  stack = (int *) malloc(1024 * sizeof(int)); 
  a = 1; b = 3; c = 7;

  writePort(0, 0xc1);
  writePort(0, 0xc2);
  writePort(0, 0xc3);

  fprintf(stderr, "[%d] executing context 1\n", me);
  createThread(0x1001, 1, &stack[255], &child_func, &a);
  fprintf(stderr, "[%d] executing context 2\n", me);
  createThread(0x1002, 2, &stack[511], &child_func, &b);
  fprintf(stderr, "[%d] executing context 3\n", me);
  createThread(0x1003, 3, &stack[767], &child_func, &c);

  writePort(1, 0x1000 + 0x1001);

  i = waitThread(0x1001); fprintf(stderr, "#%d#", i);
  i = waitThread(0x1002); fprintf(stderr, "#%d#", i);
  i = waitThread(0x1003); fprintf(stderr, "#%d#", i);

  ptr = &global_value;
  fprintf(stderr, "[%d] global value = 0x%08x\n", me, *ptr);

  free(stack);
  fprintf(stderr, "[%d] %s end\n", me, EXEC_NAME);

}
