/*
 * test-lock.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * The goal of this executable is to check out
 * hardware locks.
 *
 */

#include <stdio.h>
#include <string.h>
#include "ssmt-2.h"


#define EXEC_NAME               "test-lock"

#define FALSE                   0
#define TRUE                    1



int child_func(unsigned int me, int * param)
{
  SS_WORD_TYPE msg;

  writePort(2000 + me, 0x61);
  fprintf(stderr, "[%d] child_func(param:%d)\n", me, *param);
  readPort(&msg, 0x61);

  return(*param + 9);
} /* child_func */



void main(int argc, char **argv)
{
  unsigned int me;              /* context id for myself */
  unsigned int i;
  SS_WORD_TYPE msg;             /* message to transmit/receive */
  int *stack;
  int a;

  me = 0;

  fprintf(stderr, "[%d] %s begin\n", me, EXEC_NAME);
  fprintf(stderr, "[%d] addr child_func: 0x%08x\n", me, &child_func);

  fprintf(stderr, "[%d] initializing stack\n", me);
  stack = (int *) malloc(1024 * sizeof(int));

  fprintf(stderr, "[%d] initializing MMU config\n", me);

  setMMUconfig(1, 0);
  setMMUconfig(2, 0);
  setMMUconfig(3, 0);

  a = 897;

  writePort(2000 + me, 0x61);
  fprintf(stderr, "[%d] executing context 1(91)\n", me);
  readPort(&msg, 0x61);
  createThread(91, 1, &stack[255], &child_func, &a);
  writePort(2000 + me, 0x61);
  fprintf(stderr, "[%d] executing context 2(92)\n", me);
  readPort(&msg, 0x61);
  createThread(92, 2, &stack[511], &child_func, &a);
  writePort(2000 + me, 0x61);
  fprintf(stderr, "[%d] executing context 3(93)\n", me);
  readPort(&msg, 0x61);
  createThread(93, 3, &stack[767], &child_func, &a);

  a = waitThread(91);
  writePort(2000 + me, 0x61);
  fprintf(stderr, "[%d] executing context 1(91)\n", me);
  readPort(&msg, 0x61);
  createThread(94, 1, &stack[255], &child_func, &a);
  a = waitThread(92);
  a = waitThread(93);
  a = waitThread(94);

  free(stack);

  fprintf(stderr, "[%d] %s end\n", me, EXEC_NAME);

}
