/*
 * test-philo-4.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * Ce test utilise les verrous pour rserver les fourchettes.
 *
 */

#include <stdio.h>
#include "ssmt-3.h"


#define EXEC_NAME               "test-philo-4"
#define NUM_CXT                 8

#define LEFT_FORK               0
#define RIGHT_FORK              1

#define FALSE                   0
#define TRUE                    1

#define BITES                   3

#define LOCK_START              0x60


typedef struct {
  unsigned long int random;
  unsigned long int counter;
} PARAM_T;



int philosophe(unsigned int me, PARAM_T * param)
{
  unsigned int right, left, next_right_port, next_left_port, i, j, k = 9;
  SS_WORD_TYPE msg;
  unsigned long int random = param->random;
  unsigned long int counter = param->counter;

/*    fprintf(stderr, "[%d] philosophe(param:%d)\n", me, *param); */

  right = ((me - 90 + 1) % NUM_CXT);
  left = me - 90;

  next_right_port = 2000 + me;
  next_left_port = 2200 + me;

  random = (((me + 1) * 97 + (me * 3 * me)) % 100) * 100;
/*    fprintf(stderr, "[%d] random = %d\n", me, random); */

  for(j = counter; j > 0; j--) {
    if (((me - 90) % 2)  == 0) {
      lock(next_right_port, right); /* lock right fork*/
      lock(next_left_port, left); /* lock left fork*/
    } else {
      lock(next_left_port, left); /* lock left fork*/
      lock(next_right_port, right); /* lock right fork*/
    } /* if */

    /* eating */
    
/*      fprintf(stderr, "%c", (char) 'A' + me - 90); */

    if (((me - 90) % 2)  == 0) {
      msg = unlock(left); /* unlock */
      msg = unlock(right); /* unlock */
    } else {
      unlock(right); /* unlock */
      unlock(left); /* unlock */
    } /* if */

    /* waiting */

    for(i = random; i > 0; i--)
      if ((i % 100) == 0) {
        k += i * 3;
/*          fflush(stderr); */
/*          fprintf(stderr, "%c", (char) 'a' + me - 90); */
      }
  } /* for */

/*    fprintf(stderr, "[%d] left neighbour = [%d], right neighbour = [%d]\n", */
/*            me, left, right);   */

  return(param->random + 9);


} /* philosophe */




void main(int argc, char **argv)
{
  SS_CONTEXT_TYPE me, context;
  int *stack;
  unsigned int max_cxt = 1;
  PARAM_T a;
  int toto;

  me = 0;

  fprintf(stderr, "[%d] %s begin\n", me, EXEC_NAME);

  if (argc > 1) {
    sscanf(argv[1], "%d", &(a.counter));

    if (a.counter < 1)
      a.counter = BITES;
  } else {
    a.counter = BITES;
  }

/*    fprintf(stderr, "[%d] Running for %n bites\n", me, a.counter); */

  fprintf(stderr, "[%d] initializing stack\n", me);
  stack = (int *) malloc(NUM_CXT * 2048 * sizeof(int));

  fprintf(stderr, "[%d] initializing MMU config\n", me);

  for(context = 1; context < NUM_CXT; context++) {
    loadMMUconfig(0, context);
  } /* for */

  for(context = 1; context < NUM_CXT; context++) {
    createThread(90+context, context, &stack[(context * 1024) - 1],
                 &philosophe, (void *) &a);
  } /* for */

  philosophe(90+me, (void *) &a);

  for(context = 1; context < NUM_CXT; context++) {
    toto = waitThread(90+context);
  } /* for */

  free(stack);

  fflush(stderr);
  fprintf(stderr, "\n[%d]%s end\n", me, EXEC_NAME);

}


