/*
 * test-ssmt-a
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * This code is used with test-ssmt-b. A signal is emitted to
 * the later that listen to this signal. Then, it writes in
 * register 27 a value that is dump after receiving a signal.
 *
 */

#include <stdio.h>

#define exec_name "test-ssmt-a"


void main(int argc, char **argv)
{
  register unsigned int reg = 0;
  unsigned int r26, r27, signal = 999, result = 0;
  unsigned int cxtid;

  /* get context id */
  asm("scxtctrl %0" : "=r" (cxtid));
  cxtid = cxtid & 0x0000001f;


  fprintf(stdout, "[%d] BEGIN (%s)\n", cxtid, exec_name);

  /* saving registers */
  asm("move %0,$26" : "=r" (r26));
  asm("move %0,$27" : "=r" (r27));
  /* signal to context 1 */
  asm("move $27,%0" :: "r" (signal));
  fprintf(stdout, "[%d] waiting for message\n", cxtid);
  while (reg != 999) {
    /* Waiting for context 1 */
    asm("move %0,$26" : "=r" (reg));
  }
  /* reading the result */
  asm("move %0,$27" : "=r" (result));
  /* restoring registers */
  asm("move $26,%0" :: "r" (r26));
  asm("move $27,%0" :: "r" (r27));
  fprintf(stdout, "[%d] RECEIVED: %d\n", cxtid, result); 

  /* printing $acxt */
  asm("sacxt %0" : "=r" (result));
  fprintf(stdout, "[%d] ACXT=0x%08x\n", cxtid, result); 
  
  fprintf(stdout, "[%d] END (%s)\n", cxtid, exec_name);

}
