/*
 * test-ssmt-b
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * This program is launched in conjunction with test-ssmt-a.
 * The later emit a signal which is receive by this program.
 * Then the register 27 of the context 0 is written and a
 * signal is sent.
 *
 */

#include <stdio.h>

#define exec_name "test-ssmt-b"

void main(int argc, char **argv)
{
  unsigned int reg = 12;
  unsigned int rt = 27 /* target register */;
  unsigned int rs = 0  /* target context */;
  unsigned int rd, i;
  unsigned int acxt_stop = 2, acxt_start = 3;
  unsigned int message = 98899;
  unsigned int signal = 999;
  unsigned int result;
  unsigned int cxtid;

  /* getting context id */
  asm("scxtctrl %0" : "=r" (cxtid));
  cxtid = cxtid & 0x0000001f;

  fprintf(stdout, "[%d] BEGIN (%s)\n", cxtid, exec_name);
  fprintf(stdout, "[%d] waiting for context %d\n", cxtid, rs);
  while (reg != 999) {
    /* Waiting for context 0 */
    asm("rcxt %0,$27,0" : "=r" (reg));
  }
  fprintf(stdout, "[%d] sync on context %d\n", cxtid, rs);

  fprintf(stdout, "[%d] stopping %d and SENDING %d\n",
          cxtid, rs, message);
  asm("lacxt %0" :: "r" (acxt_stop));

  /* sending the message and the acknowledgement */
  asm("wcxt %0,$27,0" :: "r" (message));
  asm("wcxt %0,$26,0" :: "r" (signal));

  asm("sacxt %0" : "=r" (result));
  fprintf(stdout, "[%d] ACXT=0x%08x\n", cxtid, result); 


  fprintf(stdout, "[%d] resuming context %d execution\n", cxtid);
  /* restarting context 0 */
  asm("lacxt %0" :: "r" (acxt_start));
  
  /* printing $acxt */
  asm("sacxt %0" : "=r" (result));
  fprintf(stdout, "[%d] ACXT=0x%08x\n", cxtid, result); 

  fprintf(stdout, "[%d] END (%s)\n", cxtid, exec_name);

}
