/*
 * test-synchro.c
 *
 * Dominik Madon, LSL/DI/EPFL, 1998
 *
 * The goal of this executable is to measure
 * performances of synchronisation.
 *
 */

#include <stdio.h>
#include <string.h>
#include "ssmt-2.h"


#define EXEC_NAME               "test-synchro"

#define FALSE                   0
#define TRUE                    1




int child_func(unsigned int me, int * param)
{
  SS_WORD_TYPE msg;

  fprintf(stderr, "[%d] child_func(param:%d)\n", me, *param);
  fprintf(stderr, "[%d] first part readings...\n", me);

  asm("nop");
  readPort(&msg, 3000);
  asm("nop");
  readPort(&msg, 3000);
  asm("nop");

  fprintf(stderr, "[%d] second part writings...\n", me);
  
  asm("nop");
  writePort(msg, 3000);
  asm("nop");
  writePort(msg, 3000);
  asm("nop");

  return(me + 3000);
} /* child_func */



void main(int argc, char **argv)
{
  unsigned int me;              /* context id for myself */
  unsigned int i;
  SS_WORD_TYPE msg;             /* message to transmit/receive */
  int *stack;

  me = 0;

  fprintf(stderr, "[%d] %s begin\n", me, EXEC_NAME);
  fprintf(stderr, "[%d] addr child_func: 0x%08x\n", me, &child_func);
  fprintf(stderr, "[%d] initializing stack\n", me);
  stack = (int *) malloc(1024 * sizeof(int));

  fprintf(stderr, "[%d] executing context 1\n", me);

  asm("nop");
  createThread(1, 1, &stack[255], &child_func, &msg);
  asm("nop");
  writePort(msg, 3000);
  asm("nop");
  fprintf(stderr, "[%d] write after read now... (delay)\n", me);
  asm("nop");
  writePort(msg, 3000);
  asm("nop");
  readPort(&msg, 3000);
  asm("nop");
  fprintf(stderr, "[%d] read after write now... (delay)\n", me);
  asm("nop");
  readPort(&msg, 3000);
  asm("nop");
  createThread(1, 1, &stack[255], &child_func, &msg);
  asm("nop");
  writePort(msg, 3000);
  asm("nop");
  fprintf(stderr, "[%d] write after read now... (delay)\n", me);
  asm("nop");
  writePort(msg, 3000);
  asm("nop");
  readPort(&msg, 3000);
  asm("nop");
  fprintf(stderr, "[%d] read after write now... (delay)\n", me);
  asm("nop");
  readPort(&msg, 3000);
  asm("nop");

  fprintf(stderr, "[%d] %s end\n", me, EXEC_NAME);

}
