/* Temporary function to check if there is no lost */
/* RS_link. For debug purposes DM */
static void
rslink_check_integrity(int nlinks)
{
  struct RS_link *rlink;
  int count = 0;

  rlink = rslink_free_list;
  while (rlink) {
    rlink = rlink->next;
    count++;
  } /* while */
  rlink = rslink_used_list;
  while (rlink) {
    rlink = rlink->next_used;
    count++;
  } /* while */
  if (nlinks != count) {
    debug("nlinks=%d count=%d\n     ");
    panic("rslink lost !\n");
  } /* if */
} /* rslink_check_integrity  */


/* For debug purposes DM */
static void
rslink_dump(struct RS_link *link, char const *name, FILE *stream)
{
  fprintf(stream, "Dumping rslink %s\n", name);
  while (link) {
    fprintf(stream, "  0x%08x ->\n", (unsigned int) link);
    link = link->next;
  }
  fprintf(stream, "  0x%08x ->\n\n", (unsigned int) link);
} /* rslink_dump */





static void
dm_regs_dump(FILE *stream, SS_CONTEXT_TYPE context)
{
  int i;

  fprintf(stream, "*** regs state for context %d\n", context);
  fprintf(stream, "    spec_mode = %s", spec_mode[context] ? "t" : "f");
  for(i = 0; i < SS_NUM_REGS; i++) {
    if (!(i % 8)) fprintf(stream, "\n    ");
    fprintf(stream, "0x%08x ", GPR(context, i));
  } /* for */
  fprintf(stream, "\n");
} /* dm_regs_dump */



static void
dm_dump_odep(FILE *stream,
             struct RUU_station *rs,
             struct RS_link *odep,
             SS_CONTEXT_TYPE context,
             const char *text)
{
  fprintf(stderr, "%s rs[%d]@", text, context);
  fprintf(stderr, "0x%08x has odep_list@0x%08x\n",
          (unsigned int) rs, (unsigned int) odep);
} /* dm_dump_odep */



#define DM_START_LIMIT 22990
#include <stdarg.h>

int
dm_debug(char *fmt, ...)
{
  va_list v;

  va_start(v, fmt);
  if (sim_total_insn > DM_START_LIMIT) {
    vfprintf(stderr, fmt, v);
    return TRUE;
  } /* if */
  return FALSE;
} /* dm_debug */

#define DM_CHECK_ADDR 0x084764fc

static int
dm_check(char *msg)
{
  static int lastvalue = 0;
  int *ptr = (int *) DM_CHECK_ADDR;

  if (lastvalue != *ptr) {
    dm_debug("newvalue = 0x%08x ", *ptr);
    dm_debug(msg);
    lastvalue = *ptr;
    return TRUE;
  } /* if */

  return FALSE;

} /* dm_check */
